#include <p18cxxx.h>
#include <p18f452.h>
#include "keypad.h"

unsigned int _key_last = 99;	//Last key pressed
char _key_prev = 0;				//Previous key pressed

//Map button codes to the right key number
unsigned int keymap[] = {1, 2, 3, -1, 4, 5, 6, -1, 7, 8, 9, -1, 10, 0, 11};

//Set up port D to take keypad input
void initKeypads(void) {
	TRISD = 0xFF;
}

//Get the last key pressed
unsigned int getPadNum(void) {
	return _key_last;
}

//Store the current key being pressed
unsigned int registerPadPress(void) {
	unsigned int data = PORTD & 0x0F;	//Grab data
	char lastpress = _key_last;
	_key_last = 99;	//Default value

/*	switch (data) {
		case 0: _key_last = 1; break;
		case 1: _key_last = 2; break;
		case 2: _key_last = 3; break;
		case 4: _key_last = 4; break;
		case 5: _key_last = 5; break;
		case 6: _key_last = 6; break;
		case 8: _key_last = 7; break;
		case 9: _key_last = 8; break;
		case 10: _key_last = 9; break;
		case 12: _key_last = 10; break;
		case 13: _key_last = 0; break;
		case 14: _key_last = 11; break;
	}		*/
	_key_last = keymap[data];
	
	if (_key_last != lastpress)
		_key_prev = 0;	//Used to determine desired character
	return _key_last;
}

//Get the character desired from the keypad
//The keypad works like a phone number pad
//By hitting the same key over and over, you scroll through
//The characters assigned to that key
char nextChar(void) {
	switch (_key_last) {
		case 2: 
			_key_prev = (_key_prev==0||_key_prev=='C')?'A':_key_prev+1;
			break;
		case 3: 
			_key_prev = (_key_prev==0||_key_prev=='F')?'D':_key_prev+1;
			break;
		case 4: 
			_key_prev = (_key_prev==0||_key_prev=='I')?'G':_key_prev+1;
			break;
		case 5: 
			_key_prev = (_key_prev==0||_key_prev=='L')?'J':_key_prev+1;
			break;
		case 6: 
			_key_prev = (_key_prev==0||_key_prev=='O')?'M':_key_prev+1;
			break;
		case 7: 
			_key_prev = (_key_prev==0||_key_prev=='S')?'P':_key_prev+1;
			break;
		case 8: 
			_key_prev = (_key_prev==0||_key_prev=='V')?'T':_key_prev+1;
			break;
		case 9: 
			_key_prev = (_key_prev==0||_key_prev=='Z')?'W':_key_prev+1;
			break;
		default: 
			_key_prev = ' ';
	}
	return _key_prev;
}

